package org.hashtree.jbrainhoney;

/**
 * Defines the interface of a simple ValueClass. Classes implementing methods in this interface must meet the documented
 * requirements.
 */
public abstract interface SimpleValueClass extends ValueClass {
	/**
	 * Returns a simple string representation of this class ({@literal e.g.} a phone number might output 970-555-1234).
	 * See overridden method documentation for specifics.
	 *
	 * @return A simple string representation of this class.
	 */
	@Override
	public abstract String toString();

	/** Defines the interface of a SimpleValueClass builder. */
	public static interface Builder extends ValueClass.Builder {
		@Override
		public abstract SimpleValueClass build();
	}
}
