package org.hashtree.jbrainhoney.compare;

/** A utility class for null comparisons. */
public final class NullComparatorUtility {
	private NullComparatorUtility() {

	}

	public static int compareIgnoreNullAndCase(final String first, final String second) {
		if(first == null) return (second == null ? 0 : -1);
		else if(second == null) return 1;
		else return first.compareToIgnoreCase(second);
	}

	public static int compareIgnoreNull(final String first, final String second) {
		if(first == null) return (second == null ? 0 : -1);
		else if(second == null) return 1;
		else return first.compareTo(second);
	}
}