package org.hashtree.jbrainhoney.cryptography;

/** An implementation of a SHA-256 based Digest. */
public final class Sha256Digest extends MessageDigest {
	private static final long serialVersionUID = 8322096837564211L;

	private Sha256Digest(final Builder builder) {
		super(builder);
	}

	/** A builder of immutable Sha256Digest instances. */
	public final static class Builder extends MessageDigest.Builder {
		public Builder(final byte[] bytes) {
			super(Algorithm.SHA256, bytes);
		}

		public Builder(final String bytes) {
			super(Algorithm.SHA256, bytes);
		}

		@SuppressWarnings("synthetic-access")
		@Override
		public Sha256Digest build() {
			return new Sha256Digest(this);
		}
	}
}