package org.hashtree.jbrainhoney.dlap.enumeration;

import java.util.EnumSet;

/** Enumerates access privileges. */
public enum AccessPrivilege implements ValueEnumeration {
	PUBLIC(1),
	PROTECTEDFREE(2),
	PROTECTEDPAID(3),
	PRIVATEDOMAIN(4),
	PRIVATEUSER(5);

	private final Integer value;

	private AccessPrivilege(final Integer value) {
		this.value = value;
	}

	@Override
	public Integer getValue() {
		return value;
	}

	public static AccessPrivilege valueOfValue(final Integer value) throws IllegalArgumentException {
		if(value == null) throw new IllegalArgumentException("Expected value to not be null.");

		AccessPrivilege enumeration = null;

		for(AccessPrivilege element : EnumSet.allOf(AccessPrivilege.class)) {
			if(element.getValue() != null && element.getValue().equals(value)) {
				enumeration = element;
				break;
			}
		}

		if(enumeration == null) throw new IllegalArgumentException("Expected value match.");

		return enumeration;
	}
}