package org.hashtree.jbrainhoney.dlap.enumeration;

import java.util.EnumSet;

/** Enumerates course schemas. */
public enum CourseSchema implements ValueEnumeration {
	GOCOURSE(1),
	BRAINHONEY(2);

	private final Integer value;

	private CourseSchema(final Integer value) {
		this.value = value;
	}

	@Override
	public Integer getValue() {
		return value;
	}

	public static CourseSchema valueOfValue(final Integer value) throws IllegalArgumentException {
		if(value == null) throw new IllegalArgumentException("Expected value to not be null.");

		CourseSchema enumeration = null;

		for(CourseSchema element : EnumSet.allOf(CourseSchema.class)) {
			if(element.getValue() != null && element.getValue().equals(value)) {
				enumeration = element;
				break;
			}
		}

		if(enumeration == null) throw new IllegalArgumentException("Expected value match.");

		return enumeration;
	}
}