package org.hashtree.jbrainhoney.dlap.enumeration;

import java.util.EnumSet;

/** Enumerates section types. */
public enum SectionType implements ValueEnumeration {
	CONTINUOUS("Continuous"),
	RANGE("Range");

	private final String value;

	private SectionType(final String value) {
		this.value = value;
	}

	@Override
	public String getValue() {
		return value;
	}

	public static SectionType valueOfValue(final String value) throws IllegalArgumentException {
		if(value == null) throw new IllegalArgumentException("Expected value to not be null.");

		SectionType enumeration = null;

		for(SectionType element : EnumSet.allOf(SectionType.class)) {
			if(element.getValue() != null && element.getValue().equals(value)) {
				enumeration = element;
				break;
			}
		}

		if(enumeration == null) throw new IllegalArgumentException("Expected value match.");

		return enumeration;
	}
}