package org.hashtree.jbrainhoney.dlap.validate;

/** A validator class for a username attribute. */
public final class UsernameAttributeValidator implements AttributeValidator<String> {
	private volatile static UsernameAttributeValidator instance;

	private UsernameAttributeValidator() {

	}

	@Override
	public boolean isValid(final String username) {
		if(username == null || username.length() == 0 || username.length() > 128 || !username.matches("^([^/]+?)$"))
			return false;
		else return true;
	}

	public static UsernameAttributeValidator getInstance(){
		if(instance == null) synchronized(UsernameAttributeValidator.class) {
			if(instance == null) instance = new UsernameAttributeValidator();
		}

		return instance;
	}

	@Override
	public final java.lang.Object clone() throws CloneNotSupportedException {
		 throw new CloneNotSupportedException();
	}
}