package org.hashtree.jbrainhoney.network;

/**
 * Defines the interface of an Common Internet based Rfc3986Uri. Mimics functionality in section 3.2.1 of RFC 3986.
 *
 * @see <a href="http://tools.ietf.org/html/rfc3986#section-3.2.1">RFC 3986 - Section 3.2.1</a>
 */
public abstract interface CommonInternetUri extends Rfc3986Uri {
	public abstract String getUsername();

	public abstract String getPassword();

	/** Defines the interface of a CommonInternetUri builder. */
	public static interface Builder extends Rfc3986Uri.Builder {
		public abstract CommonInternetUri.Builder setUsername(final String username);

		public abstract CommonInternetUri.Builder setPassword(final String password);

		@Override
		public abstract CommonInternetUri build();
	}
}