package org.hashtree.jbrainhoney.network.http.request;

import org.hashtree.jbrainhoney.ComplexValueClass;

/**
 * Defines the interface of a request body ({@literal i.e.} message / entity body).
 *
 * @see <a href="http://www.w3.org/Protocols/rfc2616/rfc2616-sec4.html#sec4.3">RFC 2616 - Section 4.3</a>
 */
public abstract interface Body extends ComplexValueClass {
	public abstract Object getValue();

	public abstract String getMimeType();

	/** Defines the interface of a Body builder. */
	public static interface Builder extends ComplexValueClass.Builder {
		@Override
		public abstract Body build();
	}
}
