package org.hashtree.jbrainhoney.time;

import org.joda.time.DateTime;
import org.joda.time.DateTimeZone;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;

/** A utility class for the Joda-Time DateTime class. */
public final class DateTimeUtility {
	private DateTimeUtility() {

	}

	public static DateTime valueOf(final String dateTime) {
		StringBuilder pattern = new StringBuilder();

		pattern.append("yyyy-MM-dd'T'HH:mm:ss");

		// Possible for date not to have S (e.g. minimum and maximum dates do not).
		if(dateTime.length() >= 22) {
			pattern.append(".");

			// Length with one S is 22. S could be 1 to n length.
			for(int i = 21; i < dateTime.length(); i++) {
				pattern.append("S");
			}
		}

		pattern.append("'Z'");

		DateTimeFormatter formatter = DateTimeFormat.forPattern(pattern.toString());

		return formatter.withZone(DateTimeZone.UTC).parseDateTime(dateTime);
	}
}